# This file is a template, and might need editing before it works on your project.
# Official docker image.
image: docker:latest

services:
  - docker:dind

stages:
  - build
  - test
  - deploy

variables:
  DOCKER_DRIVER: overlay
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:test
before_script:
  - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY

build-master:
  stage: build
  script:
#    - docker build --pull -t "$CI_REGISTRY_IMAGE:test" .
#    - docker push "$CI_REGISTRY_IMAGE:test"
    - docker build --pull -f Dockerfile-test -t "$CONTAINER_TEST_IMAGE" .
    - docker push "$CONTAINER_TEST_IMAGE"
  only:
    - master

build:
  stage: build
  script:
    - docker build --pull  -t "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG" .
    - docker push "$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG"
  except:
    - master

test-master:
  stage: test
  script:
    - docker run $CONTAINER_TEST_IMAGE
  dependencies:
    - build-master

deploy-master:
  stage: deploy
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE" .
    - docker push "$CI_REGISTRY_IMAGE"
  dependencies:
    - test-master
